require 'shadow_cabinet/client'
require 'shadow_cabinet/version'

module ShadowCabinet
  def self.client(url:, key:, secret:)
    Client::Real.new(url: url, key: key, secret: secret)
  end

  def self.update_box(api, id, content)
    begin
      data = api.patch(
        path: "/boxes/#{id}",
        data: {
          "box" => {
            "content" => content
          }
        }.to_json
      )
    rescue
      return false
    end

    true
  end
end
