require 'faraday'
require 'shadow_cabinet/client/base'
require 'shadow_cabinet/client/real/request'

module ShadowCabinet
  module Client
    class Real < Base
      private
      def connector
        @connector ||= Faraday.new(url: base_url) do |faraday|
          faraday.headers.merge!(
            {
              'Content-Type' => 'application/json',
              'Accept' => 'application/json',
              'User-Agent' => 'shadow_cabinet-client/0.1.0 (https://github.com/ess/shadow_cabinet-client)',
              'Authorization' => "#{key}:#{secret}"
            }
          )

          faraday.request :url_encoded
          faraday.adapter Faraday.default_adapter
        end
      end

      def make_request(verb:, request_url:, data: nil)
        Request.perform(
          verb: verb,
          connector: connector,
          request_url: request_url,
          data: data
        )
      end
    end
  end
end
