require 'shadow_cabinet/client/base'
require 'shadow_cabinet/client/real/request/patch'
require 'shadow_cabinet/client/real/request/put'

module ShadowCabinet
  module Client
    class Real < Base
      module Request
        KNOWN = {
          patch: Patch,
          put: Put,
        }

        def self.perform(verb:, connector:, request_url:, data: nil)
          (KNOWN[verb] || Base).
            new(connector: connector, request_url: request_url, data: data).
            perform
        end
      end
    end
  end
end
