require 'shadow_cabinet/client/base'
require 'shadow_cabinet/client/real/request/base'

module ShadowCabinet
  module Client
    class Real < Base
      module Request
        # Implementation for the HTTP PUT verb
        class Put < Base

          def perform
            response = connector.put(path, data) do |req|
              params.keys.each do |key|
                req.params[key] = params[key]
              end
            end

            process_response(response)
          end

        end
      end
    end
  end
end
