module ShadowCabinet
  module Client
    # A structure used within client implementations to encapsulate the result
    # of a given operation. The result contains both a body and an error. If
    # an error is present, the body should be ignored and the error should be
    # handled (or raised). Otherwise, the body should be considered the de-facto
    # result of the operation. This pattern is stolen from Rust, Go, Haskell and
    # the like, but done so in a VERY naive manner.
    Result = Struct.new(:body, :error) do
      def initialize(body: nil, error: nil)
        self.body = body
        self.error = error
      end

      def error_present?
        !self.error.nil?
      end
    end
  end
end
